Imports System
Imports System.Net.Sockets
Imports System.Net
Imports System.IO
Imports System.Text

Public Class Radrec

    Private MyWriter As StreamWriter
    Private BaseName As String
    Private AudioFile As BinaryWriter
    Private Client As TcpClient
    Private TCPStream As NetworkStream

    Public [Stop] As Boolean

    Public Sub New(ByVal Pid As Int16, ByVal TCPPort As Int16, HostIP as IPAddress)
        Me.Stop = False
        BaseName = String.Format("Audio_{0:d4}", Pid)

        Client = New TcpClient()

        Client.Connect(HostIP, TCPPort)

        TCPStream = Client.GetStream
        Dim MyStream As FileStream = New FileStream(BaseName & ".txt", FileMode.Create)

        MyWriter = New StreamWriter(MyStream)

        Dim getStr As String = String.Format("GET /{0:X} HTTP/1.0" & vbCrLf & vbCrLf, Pid)
        Console.WriteLine(getStr)
        Dim httpGet As Byte() = Encoding.ASCII.GetBytes(getStr)
        TCPStream.Write(httpGet, 0, httpGet.Length)
        Console.WriteLine(httpGet)

    End Sub

    Public Sub Record()
        'Buffer Eigenschaften
        Console.WriteLine("Aufnahme gestartet!")
        Dim Length As Int32 = &H10000 '64KB
        Dim LastIndex As Int32 = Length - 1
        Dim Buffer(LastIndex) As Byte

        Dim FileNr As Int16 = 1

        Dim Pos As Int32 = 64
        Dim EndPTS As Integer

        Dim CurrentPTS As AudioPES
        Dim LastPTS As AudioPES

        TCPStream.Read(Buffer, 0, 42) ' HTTP/1.1 200 OK ... ueberspringen
        Buffer = ReadStream(LastIndex)

        Pos = GetEnd(Buffer, Pos)
        Select Case Pos
            Case -1
                MyWriter.WriteLine("Es handelt sich nicht um MP2-Daten!")
                Exit Sub
            Case Else
                CurrentPTS = New AudioPES(Buffer, Pos, Me)
                Pos += CurrentPTS.Header
        End Select

        AudioFile = NewAudioFile(FileNr)

        Do
            If Me.Stop Then Exit Do
            Pos = GetEnd(Buffer, Pos)

            Select Case Pos
                Case -1
                    'Es wurde kein Header mehr im aktuellen Buffer gefunden, daher
                    'werden die bisherigen Daten vom StartPTS bis zur aktuellen
                    'Position gespeichert
                    CurrentPTS.Write(Buffer)
                    'und anschlieend der Buffer wieder aufgefllt
                    Buffer = ReadStream(LastIndex, Buffer)
                    Pos = 4

                Case Else
                    EndPTS = Pos - 4
                    Select Case CurrentPTS.IsComplete(EndPTS)
                        Case -1 'Es fehlen noch Daten. Ein Fehler kann durch weitere Daten behoben werden
                            Pos += 1
                        Case 0 'Alle Daten vorhanden. Es kann geschrieben werden
                            'Zuerst wird der Buffer aufgefllt
                            CurrentPTS.Write(Buffer, EndPTS)

                            'Zuerst wird geprft ob der vorhergehende Frame
                            'krzer ist als der aktuelle, da der letzte Frame
                            'eines Songs immer krzer ist.
                            If Not LastPTS Is Nothing Then
                                If CurrentPTS.Length > LastPTS.Length Then
                                    'Nun wird geprft ob der Frame mit 0xFFFDA0 beginnt
                                    'da es sich dann definitiv um einen neuen Song handelt.
                                    'Diese berprfung muss noch so gendert werden, das
                                    'einfach auf einen gltigen MP2-Header geprft wird
                                    If CurrentPTS.IsNewSong Then
                                        FileNr += 1
                                        AudioFile = NewAudioFile(FileNr)
                                        MyWriter.WriteLine("+++ +++ +++ NEUE DATEI +++ +++ +++")
                                    End If
                                End If
                            End If
                            CurrentPTS.ToFile(AudioFile)

                            LastPTS = CurrentPTS

                            If Pos > LastIndex - 259 Then
                                'Es besteht die Gefahr, dass bei der Auswertung des Headers
                                'ein Bufferberlauf stattfindet. Daher werden die letzten
                                'Bytes des aktuellen Buffers in einen neuen geschrieben und
                                'dieser anschlieend aufgefllt.
                                Buffer = ReadStream(LastIndex, Buffer, Pos)
                                Pos = 4
                                MyWriter.WriteLine("Neuer Buffer, wegen eventuellem berlauf!")
                            End If

                            CurrentPTS = New AudioPES(Buffer, Pos, Me)

                            Pos = CurrentPTS.StartPos
                        Case 1
                            'Wenn der Frame lnger ist, als er lt. Header sein
                            'sollte, dann wird an Stelle des neuen Frames der
                            'vorhergehende nochmal geschrieben und danach nach
                            'dem nchsten Header gesucht.
                            MyWriter.WriteLine("Audio Frame zu lang!")
                            If Not LastPTS Is Nothing Then LastPTS.ToFile(AudioFile)
                            CurrentPTS = New AudioPES(Buffer, Pos, Me)
                    End Select
            End Select
        Loop

        MyWriter.Close()
        Client.Close()
    End Sub

    Private Function NewAudioFile(ByVal FileNr As Int32) As BinaryWriter
        Dim FileName As String
        FileName = String.Format("{0}_{1:d4}.mp2", BaseName, FileNr)
        Dim AudioStream As FileStream = New FileStream(FileName, FileMode.Create)
        Dim AudioFile As BinaryWriter = New BinaryWriter(AudioStream)

        Return AudioFile
    End Function

    Private Function GetEnd(ByVal Buffer() As Byte, ByVal Pos As Int32) As Int32
        Do
            'Es wird der Header gesucht und somit das Ende der vorhergehenden Frames
            If Pos = Buffer.Length Then
                Return -1
            Else
                If (Buffer(Pos - 3)) = &H0 AndAlso _
                   (Buffer(Pos - 2)) = &H0 AndAlso _
                   (Buffer(Pos - 1)) = &H1 Then
                    Select Case Buffer(Pos)
                        Case &HC0 To &HDF 'Audio lt. Norm
                            Return Pos
                    End Select
                End If
            End If

            Pos += 1
        Loop
    End Function

    Private Function ReadStream(ByVal LastIndex As Int32) As Byte()
        Dim Pos As Int32
        Dim Buffer(LastIndex) As Byte

        For Pos = 0 To (LastIndex)
            TCPStream.Read(Buffer, Pos, 1)
        Next

        Return Buffer
    End Function

    Private Function ReadStream(ByVal LastIndex As Int32, ByVal LastBuffer() As Byte) As Byte()
        Dim Pos As Int32
        Dim Buffer(LastIndex) As Byte

        Buffer(0) = LastBuffer(LastIndex - 4)
        Buffer(1) = LastBuffer(LastIndex - 3)
        Buffer(2) = LastBuffer(LastIndex - 2)
        Buffer(3) = LastBuffer(LastIndex - 1)
        Buffer(4) = LastBuffer(LastIndex)

        For Pos = 5 To LastIndex
            TCPStream.Read(Buffer, Pos, 1)
        Next

        Return Buffer
    End Function

    Private Function ReadStream(ByVal LastIndex As Int32, ByVal LastBuffer() As Byte, ByVal CurrentPos As Int32) As Byte()
        Dim Pos As Int32
        Dim Anzahl As Int16 = 4

        Dim Buffer(LastIndex) As Byte

        Buffer(0) = LastBuffer(CurrentPos - 4)
        Buffer(1) = LastBuffer(CurrentPos - 3)
        Buffer(2) = LastBuffer(CurrentPos - 2)
        Buffer(3) = LastBuffer(CurrentPos - 1)

        Do
            If CurrentPos > LastIndex Then Exit Do
            Buffer(Anzahl) = LastBuffer(CurrentPos)
            CurrentPos += 1
            Anzahl += 1
        Loop

        For Pos = Anzahl To LastIndex
            TCPStream.Read(Buffer, Pos, 1)
        Next

        Return Buffer
    End Function

    'Ein kompletter AudioFrame inkl. Header
    Private Class AudioPES
        Public PacketData As New ArrayList()
        Public Header As Int16
        Public Length As Int32
        Public StartPos As Int32
        Private Parent As Radrec

        Public Sub New(ByVal Buffer() As Byte, ByVal Pos As Int32, ByVal Parent As Radrec)
            Me.Parent = Parent
            Me.Header = Buffer(Pos + 5)
            Me.Length = (Buffer(Pos + 1) * 256) + Buffer(Pos + 2)
            StartPos = Pos + 6 + Me.Header

            Dim i As Int16
            For i = -3 To (Me.Header + 9)
                Me.Parent.MyWriter.Write("{0:x2} ", Buffer(Pos + i))
            Next
        End Sub

        Public Sub Write(ByVal buffer() As Byte)
            Dim Pos As Int32

            For Pos = StartPos To (buffer.Length - 6)
                PacketData.Add(buffer(Pos))
            Next
            StartPos = 0
        End Sub

        Public Sub Write(ByVal Buffer() As Byte, ByVal EndPos As Int32)
            Dim Pos As Int32

            For Pos = StartPos To EndPos
                PacketData.Add(Buffer(Pos))
            Next
        End Sub

        Public Sub ToFile(ByVal AudioFile As BinaryWriter)
            Dim Data As Byte

            For Each Data In PacketData
                AudioFile.Write(Data)
                'Me.Parent.MyWriter.Write("{0:x2} ", Data)
            Next

            Me.Parent.MyWriter.WriteLine("{0:d4} {1:d4}", PacketData.Count, Length)
        End Sub

        Public ReadOnly Property IsComplete(ByVal Pos As Int32) As Int16
            Get
                Dim curLength As Int32
                curLength = ((Pos + 1) - StartPos) + PacketData.Count + Me.Header + 3

                Select Case curLength
                    Case Is < Length
                        Return -1
                    Case Length
                        Return 0
                    Case Is > Length
                        Me.Parent.MyWriter.WriteLine()
                        Me.Parent.MyWriter.WriteLine("Too Long " & curLength & " - " & Length)
                        Return 1
                End Select
            End Get
        End Property

        Public ReadOnly Property IsNewSong() As Boolean
            Get
                If CByte(Me.PacketData(0)) = &HFF AndAlso _
                    CByte(Me.PacketData(1)) = &HFD AndAlso _
                    CByte(Me.PacketData(2)) = &HA0 Then
                    Return True
                Else
                    Return False
                End If
            End Get
        End Property
    End Class
End Class
